# use as git subtree

## add gitlab-ci to your extension
```
git subtree add --prefix Build/gitlab-ci https://git.slub-dresden.de/typo3/gitlab-ci.git main --squash
```

## add a .gitlab-ci.yml to your extension root, with this content
```
include:
  - local: 'Build/gitlab-ci/extension-gitlab-ci.yml'
```

## pull from remote
```
git subtree pull --prefix Build/gitlab-ci https://git.slub-dresden.de/typo3/gitlab-ci.git main --squash
```
## push from remote
```
git subtree push --prefix Build/gitlab-ci https://git.slub-dresden.de/typo3/gitlab-ci.git main
```
# use from remote repository

## add a .gitlab-ci.yml to your extension root, with this content
```
include:
  - remote: 'https://git.slub-dresden.de/typo3/gitlab-ci/-/raw/main/extension-gitlab-ci.yml'
```
# create a .gitignore
## in your extension root, with this content
```
composer.lock
/Build/gitlab-ci/project
/Build/gitlab-ci/project-gitlab-ci.yml
/vendor
/public
.php_cs.cache
.php-cs-fixer.cache
```
## add this lines to your project root
```
/Build/gitlab-ci/extension
/Build/gitlab-ci/extension-gitlab-ci.yml
.php_cs.cache
.php-cs-fixer.cache
```

# install rector in your local environment
```
composer require --dev ssch/typo3-rector
```
## run rector to fix your code
```
./vendor/bin/rector process . --config Build/gitlab-ci/extension/typo3-rector.php
```

# install php-cs-fixer in your local environment
```
composer require --dev friendsofphp/php-cs-fixer
```

## run php-cs-fixer to fix your code
```
./vendor/bin/php-cs-fixer fix --config Build/gitlab-ci/extension/php-cs-fixer.php
```

# install typo3-typoscript-lint in your local environment
```
composer require --dev helmich/typo3-typoscript-lint
```

## run typo3-typoscript-lint to display the errors
```
vendor/bin/typoscript-lint -c Build/gitlab-ci/extension/typoscript-lint.yml --fail-on-warnings
```
